/* ***********************************************************
 * This file was automatically generated on 2019-09-20.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Generates configurable DC voltage between 0V and 5V
 */
public class BrickletAnalogOut extends Device {
	public final static int DEVICE_IDENTIFIER = 220;
	public final static String DEVICE_DISPLAY_NAME = "Analog Out Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "analogout", DEVICE_IDENTIFIER, BrickletAnalogOut.class);

	public final static byte FUNCTION_SET_VOLTAGE = (byte)1;
	public final static byte FUNCTION_GET_VOLTAGE = (byte)2;
	public final static byte FUNCTION_SET_MODE = (byte)3;
	public final static byte FUNCTION_GET_MODE = (byte)4;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;

	public final static short MODE_ANALOG_VALUE = (short)0;
	public final static short MODE_1K_TO_GROUND = (short)1;
	public final static short MODE_100K_TO_GROUND = (short)2;
	public final static short MODE_500K_TO_GROUND = (short)3;


	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletAnalogOut(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MODE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
	 * Calling this function will set the mode to 0 (see {@link BrickletAnalogOut#setMode(short)}).
	 * 
	 * The default value is 0 (with mode 1).
	 */
	public void setVoltage(int voltage) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VOLTAGE, this);

		bb.putShort((short)voltage);

		sendRequest(bb.array());
	}

	/**
	 * Returns the voltage as set by {@link BrickletAnalogOut#setVoltage(int)}.
	 */
	public int getVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnection.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Sets the mode of the analog value. Possible modes:
	 * 
	 * * 0: Normal Mode (Analog value as set by {@link BrickletAnalogOut#setVoltage(int)} is applied)
	 * * 1: 1k Ohm resistor to ground
	 * * 2: 100k Ohm resistor to ground
	 * * 3: 500k Ohm resistor to ground
	 * 
	 * Setting the mode to 0 will result in an output voltage of 0. You can jump
	 * to a higher output voltage directly by calling {@link BrickletAnalogOut#setVoltage(int)}.
	 * 
	 * The default mode is 1.
	 */
	public void setMode(short mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_MODE, this);

		bb.put((byte)mode);

		sendRequest(bb.array());
	}

	/**
	 * Returns the mode as set by {@link BrickletAnalogOut#setMode(short)}.
	 */
	public short getMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletAnalogOut.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAnalogOut.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogOutConfig cfg = (BrickletAnalogOutConfig) config.as(BrickletAnalogOutConfig.class);
        
        
		{
		BrickletAnalogOutVoltageConfig channelCfg = getChannelConfigFn.apply("AnalogOutVoltage").as(BrickletAnalogOutVoltageConfig.class);
		
		}
		{
		BrickletAnalogOutModeConfig channelCfg = getChannelConfigFn.apply("AnalogOutMode").as(BrickletAnalogOutModeConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletAnalogOutConfig cfg = (BrickletAnalogOutConfig) config.as(BrickletAnalogOutConfig.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAnalogOutConfig cfg = (BrickletAnalogOutConfig) config.as(BrickletAnalogOutConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("AnalogOutVoltage");
		result.add("AnalogOutMode");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "AnalogOutVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "AnalogOutVoltage"), "Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:AnalogOutVoltage")).withDescription("The output voltage. The possible range is 0V to 5V. Sending a command to this channel will set the Mode to Analog Value.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(5)).withPattern("%.3f %unit%").build().toStateDescription()).build();
            case "AnalogOutMode":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "AnalogOutMode"), "Mode", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:AnalogOutMode")).withDescription("The mode of the output. Setting the mode to Analog Value will result in an output voltage of 0. You can jump to a higher output voltage directly by sending a command to the Voltage Channel.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(7)).withPattern("%d").withReadOnly(false).withOptions(Arrays.asList(new StateOption("0", "Analog Value"), new StateOption("1", "1k To Ground"), new StateOption("2", "100k To Ground"), new StateOption("3", "500k To Ground"))).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Analog Out Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage between 0V and 5V").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("AnalogOutVoltage", new ChannelTypeUID("tinkerforge", "AnalogOutVoltage")).build(), new ChannelDefinitionBuilder("AnalogOutMode", new ChannelTypeUID("tinkerforge", "AnalogOutMode")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:analogout":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:AnalogOutVoltage":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:AnalogOutMode":
                return new ConfigDescription(uri, Arrays.asList());
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogOutConfig cfg = (BrickletAnalogOutConfig) config.as(BrickletAnalogOutConfig.class);
        switch(value) {
            case "AnalogOutVoltage": {
                   BrickletAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutVoltageConfig.class);
                   updateStateFn.accept(value, transformAnalogOutVoltageGetter0(this.getVoltage(), cfg));
                   return;
               }
            case "AnalogOutMode": {
                   BrickletAnalogOutModeConfig channelCfg = channelConfig.as(BrickletAnalogOutModeConfig.class);
                   updateStateFn.accept(value, transformAnalogOutModeGetter0(this.getMode(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletAnalogOutConfig cfg = (BrickletAnalogOutConfig) config.as(BrickletAnalogOutConfig.class);
        switch(channel) {
            case "AnalogOutVoltage":
                if (command instanceof QuantityType) {
                    BrickletAnalogOutVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutVoltageConfig.class);
                    QuantityType cmd = (QuantityType) command;
                    this.setVoltage((int)Math.round(cmd.doubleValue() * 1000.0));
                    result.add(new SetterRefresh("AnalogOutMode", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a QuantityType.", command.getClass().getName(), channel);
                }
                break;
            case "AnalogOutMode":
                if (command instanceof QuantityType) {
                    BrickletAnalogOutModeConfig channelCfg = channelConfig.as(BrickletAnalogOutModeConfig.class);
                    QuantityType cmd = (QuantityType) command;
                    this.setMode(cmd.shortValue());
                    result.add(new SetterRefresh("AnalogOutVoltage", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a QuantityType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformAnalogOutVoltageGetter0(int value, BrickletAnalogOutConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformAnalogOutModeGetter0(short value, BrickletAnalogOutConfig cfg) {
        return new QuantityType(value, SmartHomeUnits.ONE);
    }
}
