/* ***********************************************************
 * This file was automatically generated on 2019-09-20.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Generates configurable DC voltage between 0V and 12V
 */
public class BrickletAnalogOutV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 256;
	public final static String DEVICE_DISPLAY_NAME = "Analog Out Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "analogoutv2", DEVICE_IDENTIFIER, BrickletAnalogOutV2.class);

	public final static byte FUNCTION_SET_OUTPUT_VOLTAGE = (byte)1;
	public final static byte FUNCTION_GET_OUTPUT_VOLTAGE = (byte)2;
	public final static byte FUNCTION_GET_INPUT_VOLTAGE = (byte)3;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;



	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletAnalogOutV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_OUTPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_OUTPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_INPUT_VOLTAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Sets the voltage in mV. The possible range is 0V to 12V (0-12000).
	 */
	public void setOutputVoltage(int voltage) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_OUTPUT_VOLTAGE, this);

		bb.putShort((short)voltage);

		sendRequest(bb.array());
	}

	/**
	 * Returns the voltage as set by {@link BrickletAnalogOutV2#setOutputVoltage(int)}.
	 */
	public int getOutputVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OUTPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnection.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the input voltage in mV.
	 */
	public int getInputVoltage() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_INPUT_VOLTAGE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int voltage = IPConnection.unsignedShort(bb.getShort());

		return voltage;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletAnalogOutV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAnalogOutV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        
        
		{
		BrickletAnalogOutV2InputVoltageConfig channelCfg = getChannelConfigFn.apply("AnalogOutV2InputVoltage").as(BrickletAnalogOutV2InputVoltageConfig.class);
		
		}
		{
		BrickletAnalogOutV2OutputVoltageConfig channelCfg = getChannelConfigFn.apply("AnalogOutV2OutputVoltage").as(BrickletAnalogOutV2OutputVoltageConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("AnalogOutV2InputVoltage");
		result.add("AnalogOutV2OutputVoltage");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "AnalogOutV2InputVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "AnalogOutV2InputVoltage"), "Input Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:AnalogOutV2InputVoltage")).withDescription("The input voltage")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(15)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "AnalogOutV2OutputVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "AnalogOutV2OutputVoltage"), "Output Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:AnalogOutV2OutputVoltage")).withDescription("The output voltage. The possible range is 0V to 12V")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(12)).withPattern("%.3f %unit%").build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Analog Out Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage between 0V and 12V").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("AnalogOutV2InputVoltage", new ChannelTypeUID("tinkerforge", "AnalogOutV2InputVoltage")).build(), new ChannelDefinitionBuilder("AnalogOutV2OutputVoltage", new ChannelTypeUID("tinkerforge", "AnalogOutV2OutputVoltage")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:analogoutv2":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:AnalogOutV2InputVoltage":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:AnalogOutV2OutputVoltage":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        switch(value) {
            case "AnalogOutV2InputVoltage": {
                   BrickletAnalogOutV2InputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2InputVoltageConfig.class);
                   updateStateFn.accept(value, transformAnalogOutV2InputVoltageGetter0(this.getInputVoltage(), cfg));
                   return;
               }
            case "AnalogOutV2OutputVoltage": {
                   BrickletAnalogOutV2OutputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2OutputVoltageConfig.class);
                   updateStateFn.accept(value, transformAnalogOutV2OutputVoltageGetter0(this.getOutputVoltage(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        switch(channel) {
            case "AnalogOutV2OutputVoltage":
                if (command instanceof QuantityType) {
                    BrickletAnalogOutV2OutputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2OutputVoltageConfig.class);
                    QuantityType cmd = (QuantityType) command;
                    this.setOutputVoltage((int)Math.round(cmd.doubleValue() * 1000.0));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a QuantityType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformAnalogOutV2InputVoltageGetter0(int value, BrickletAnalogOutV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformAnalogOutV2OutputVoltageGetter0(int value, BrickletAnalogOutV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
}
